#!/usr/bin/python

# Jean-Franois Roche (jfroche@jfroche.be)
#  ZPhotoSlides 0.3
#  GNU GPL
# 

import os, sys, copy
import PIL.Image
import traceback

class Img:
	
	def __init__(self, path):
		fullpath = os.path.abspath(os.path.normpath(path))
		self.imgpath = fullpath
#		print fullpath
#                print 'Location !!!: ' + self.imgpath
		try:
			self.im = PIL.Image.open(self.imgpath)
		except:
                        print 'ERROR %s' % self.imgpath
#			sys.exit("Error : not a valid image file")
#			print "Error: not a valid image file"

		self.imgname = os.path.basename(self.imgpath)
		self.basepath = os.path.dirname(self.imgpath)
		self.imgformat = self.im.format		# JPEG, GIF, ...
		self.imgmode = self.im.mode			# mode P, mode RGB, ...

	def getimgpath(self):
		return self.imgpath

	def getimgsize(self):
		return self.im.size
	
	def getimgwidth(self):
		return self.im.size[0]
	
	def getimgheight(self):
		return self.im.size[1]

	def getimgweight(self):
		return os.path.getsize(self.imgpath)

	def thumbnailize(self, size, prefix,output):
		""" 'size' is the width of the thumbnail.
                     prefix is the name of the beginning of the thumbnail files
			'output' is an optional path where the thumbnail will be saved.
		"""
		self.size = (size, 4000)
		self.thumbname = "%s%s"%(prefix,self.imgname)
		self.thumbname = prefix + self.thumbname
		default = os.path.join(self.basepath, self.thumbname)
	#	try:
		self.output = output
	#	except IndexError:
	#		self.output = default	
		try:
			print 'OUTPUT: %s' % self.output
			self.im.thumbnail(self.size)
			self.im.save(self.output)
		except IOError, e:
			errorlog = open("%s%s%s"%(os.curdir, os.sep, "error.log"), 'a')
			print e
			a = "Error on file %s : %s\n\n"%(self.imgpath, e)
			errorlog.write(a)
			errorlog.close()
		
	def __str__(self):
		fileinfo = "Filename = %s\nFilepath = %s"%(self.imgname, self.basepath)
		imginfo = "\nFormat : %s\nMode : %s"%(self.im.format, self.imgmode)
		imgsize = "\nWidth = %d pixels\nHeight = %d pixels"%(self.im.size[0], self.im.size[1])
		imgweight = "\nFilesize = %s bytes"%(self.getimgweight())
		total = fileinfo + imginfo + imgsize + imgweight
		return total

def saveThumbnailInThumbDirectory(image, thumbsize):
	thumbdir = "thumb"
	thumbname = "tn_%s"%(image.imgname)
	dirpath = os.path.join(image.basepath, thumbdir)
	if not os.path.exists(dirpath):
		os.mkdir(dirpath)
	thumbpath = os.path.join(dirpath, thumbname)
	image.resize(thumbsize, thumbpath)

def main():
	test = "./b.jpg"
	a = Img(test)
	a.thumbnailize(120)
	saveThumbnailInThumbDirectory(a, 120)
	#print a

if __name__ == "__main__":
	main()
